package gw.spec.core.expressions.arithmetic.multiplication
uses java.lang.Byte
uses java.lang.Character
uses java.lang.Integer
uses java.lang.Short
uses java.lang.Long
uses java.lang.Float
uses java.lang.Double
uses java.math.BigInteger
uses java.math.BigDecimal
uses gw.spec.core.expressions.arithmetic.ArithmeticTestBase

class Multiplication_ShortTest extends ArithmeticTestBase {

  function testShortPByteMultiplication() {
    assertEquals(b_int(0), b_short(0) !* p_byte(0))
    assertEquals(b_int(0), b_short(0) !* p_byte(1))
    assertEquals(b_int(0), b_short(0) !* p_byte(-1))
    assertEquals(b_int(0), b_short(0) !* p_byte(23))
    assertEquals(b_int(0), b_short(0) !* p_byte(-32))
    assertEquals(b_int(0), b_short(0) !* p_byte(Byte.MAX_VALUE))
    assertEquals(b_int(0), b_short(0) !* p_byte(Byte.MIN_VALUE))

    assertEquals(b_int(0), b_short(1) !* p_byte(0))
    assertEquals(b_int(1), b_short(1) !* p_byte(1))
    assertEquals(b_int(-1), b_short(1) !* p_byte(-1))
    assertEquals(b_int(23), b_short(1) !* p_byte(23))
    assertEquals(b_int(-32), b_short(1) !* p_byte(-32))
    assertEquals(b_int(127), b_short(1) !* p_byte(Byte.MAX_VALUE))
    assertEquals(b_int(-128), b_short(1) !* p_byte(Byte.MIN_VALUE))

    assertEquals(b_int(0), b_short(-1) !* p_byte(0))
    assertEquals(b_int(-1), b_short(-1) !* p_byte(1))
    assertEquals(b_int(1), b_short(-1) !* p_byte(-1))
    assertEquals(b_int(-23), b_short(-1) !* p_byte(23))
    assertEquals(b_int(32), b_short(-1) !* p_byte(-32))
    assertEquals(b_int(-127), b_short(-1) !* p_byte(Byte.MAX_VALUE))
    assertEquals(b_int(128), b_short(-1) !* p_byte(Byte.MIN_VALUE))

    assertEquals(b_int(0), b_short(23) !* p_byte(0))
    assertEquals(b_int(23), b_short(23) !* p_byte(1))
    assertEquals(b_int(-23), b_short(23) !* p_byte(-1))
    assertEquals(b_int(529), b_short(23) !* p_byte(23))
    assertEquals(b_int(-736), b_short(23) !* p_byte(-32))
    assertEquals(b_int(2921), b_short(23) !* p_byte(Byte.MAX_VALUE))
    assertEquals(b_int(-2944), b_short(23) !* p_byte(Byte.MIN_VALUE))

    assertEquals(b_int(0), b_short(-32) !* p_byte(0))
    assertEquals(b_int(-32), b_short(-32) !* p_byte(1))
    assertEquals(b_int(32), b_short(-32) !* p_byte(-1))
    assertEquals(b_int(-736), b_short(-32) !* p_byte(23))
    assertEquals(b_int(1024), b_short(-32) !* p_byte(-32))
    assertEquals(b_int(-4064), b_short(-32) !* p_byte(Byte.MAX_VALUE))
    assertEquals(b_int(4096), b_short(-32) !* p_byte(Byte.MIN_VALUE))

    assertEquals(b_int(0), b_short(Short.MAX_VALUE) !* p_byte(0))
    assertEquals(b_int(32767), b_short(Short.MAX_VALUE) !* p_byte(1))
    assertEquals(b_int(-32767), b_short(Short.MAX_VALUE) !* p_byte(-1))
    assertEquals(b_int(753641), b_short(Short.MAX_VALUE) !* p_byte(23))
    assertEquals(b_int(-1048544), b_short(Short.MAX_VALUE) !* p_byte(-32))
    assertEquals(b_int(4161409), b_short(Short.MAX_VALUE) !* p_byte(Byte.MAX_VALUE))
    assertEquals(b_int(-4194176), b_short(Short.MAX_VALUE) !* p_byte(Byte.MIN_VALUE))

    assertEquals(b_int(0), b_short(Short.MIN_VALUE) !* p_byte(0))
    assertEquals(b_int(-32768), b_short(Short.MIN_VALUE) !* p_byte(1))
    assertEquals(b_int(32768), b_short(Short.MIN_VALUE) !* p_byte(-1))
    assertEquals(b_int(-753664), b_short(Short.MIN_VALUE) !* p_byte(23))
    assertEquals(b_int(1048576), b_short(Short.MIN_VALUE) !* p_byte(-32))
    assertEquals(b_int(-4161536), b_short(Short.MIN_VALUE) !* p_byte(Byte.MAX_VALUE))
    assertEquals(b_int(4194304), b_short(Short.MIN_VALUE) !* p_byte(Byte.MIN_VALUE))

    assertEquals(Integer, statictypeof(b_short(0) !* p_byte(0)))
  }

  function testShortByteMultiplication() {
    assertEquals(b_int(0), b_short(0) !* b_byte(0))
    assertEquals(b_int(0), b_short(0) !* p_byte(1))
    assertEquals(b_int(0), b_short(0) !* p_byte(-1))
    assertEquals(b_int(0), b_short(0) !* b_byte(23))
    assertEquals(b_int(0), b_short(0) !* b_byte(-32))
    assertEquals(b_int(0), b_short(0) !* b_byte(Byte.MAX_VALUE))
    assertEquals(b_int(0), b_short(0) !* b_byte(Byte.MIN_VALUE))

    assertEquals(b_int(0), b_short(1) !* b_byte(0))
    assertEquals(b_int(1), b_short(1) !* p_byte(1))
    assertEquals(b_int(-1), b_short(1) !* p_byte(-1))
    assertEquals(b_int(23), b_short(1) !* b_byte(23))
    assertEquals(b_int(-32), b_short(1) !* b_byte(-32))
    assertEquals(b_int(127), b_short(1) !* b_byte(Byte.MAX_VALUE))
    assertEquals(b_int(-128), b_short(1) !* b_byte(Byte.MIN_VALUE))

    assertEquals(b_int(0), b_short(-1) !* b_byte(0))
    assertEquals(b_int(-1), b_short(-1) !* p_byte(1))
    assertEquals(b_int(1), b_short(-1) !* p_byte(-1))
    assertEquals(b_int(-23), b_short(-1) !* b_byte(23))
    assertEquals(b_int(32), b_short(-1) !* b_byte(-32))
    assertEquals(b_int(-127), b_short(-1) !* b_byte(Byte.MAX_VALUE))
    assertEquals(b_int(128), b_short(-1) !* b_byte(Byte.MIN_VALUE))

    assertEquals(b_int(0), b_short(23) !* b_byte(0))
    assertEquals(b_int(23), b_short(23) !* p_byte(1))
    assertEquals(b_int(-23), b_short(23) !* p_byte(-1))
    assertEquals(b_int(529), b_short(23) !* b_byte(23))
    assertEquals(b_int(-736), b_short(23) !* b_byte(-32))
    assertEquals(b_int(2921), b_short(23) !* b_byte(Byte.MAX_VALUE))
    assertEquals(b_int(-2944), b_short(23) !* b_byte(Byte.MIN_VALUE))

    assertEquals(b_int(0), b_short(-32) !* b_byte(0))
    assertEquals(b_int(-32), b_short(-32) !* p_byte(1))
    assertEquals(b_int(32), b_short(-32) !* p_byte(-1))
    assertEquals(b_int(-736), b_short(-32) !* b_byte(23))
    assertEquals(b_int(1024), b_short(-32) !* b_byte(-32))
    assertEquals(b_int(-4064), b_short(-32) !* b_byte(Byte.MAX_VALUE))
    assertEquals(b_int(4096), b_short(-32) !* b_byte(Byte.MIN_VALUE))

    assertEquals(b_int(0), b_short(Short.MAX_VALUE) !* b_byte(0))
    assertEquals(b_int(32767), b_short(Short.MAX_VALUE) !* p_byte(1))
    assertEquals(b_int(-32767), b_short(Short.MAX_VALUE) !* p_byte(-1))
    assertEquals(b_int(753641), b_short(Short.MAX_VALUE) !* b_byte(23))
    assertEquals(b_int(-1048544), b_short(Short.MAX_VALUE) !* b_byte(-32))
    assertEquals(b_int(4161409), b_short(Short.MAX_VALUE) !* b_byte(Byte.MAX_VALUE))
    assertEquals(b_int(-4194176), b_short(Short.MAX_VALUE) !* b_byte(Byte.MIN_VALUE))

    assertEquals(b_int(0), b_short(Short.MIN_VALUE) !* b_byte(0))
    assertEquals(b_int(-32768), b_short(Short.MIN_VALUE) !* p_byte(1))
    assertEquals(b_int(32768), b_short(Short.MIN_VALUE) !* p_byte(-1))
    assertEquals(b_int(-753664), b_short(Short.MIN_VALUE) !* b_byte(23))
    assertEquals(b_int(1048576), b_short(Short.MIN_VALUE) !* b_byte(-32))
    assertEquals(b_int(-4161536), b_short(Short.MIN_VALUE) !* b_byte(Byte.MAX_VALUE))
    assertEquals(b_int(4194304), b_short(Short.MIN_VALUE) !* b_byte(Byte.MIN_VALUE))

    assertEquals(Integer, statictypeof(b_short(0) !* b_byte(0)))
  }

  function testShortPShortMultiplication() {
    assertEquals(b_int(0), b_short(0) !* p_short(0))
    assertEquals(b_int(0), b_short(0) !* p_short(1))
    assertEquals(b_int(0), b_short(0) !* p_short(-1))
    assertEquals(b_int(0), b_short(0) !* p_short(23))
    assertEquals(b_int(0), b_short(0) !* p_short(-32))
    assertEquals(b_int(0), b_short(0) !* p_short(Short.MAX_VALUE))
    assertEquals(b_int(0), b_short(0) !* p_short(Short.MIN_VALUE))

    assertEquals(b_int(0), b_short(1) !* p_short(0))
    assertEquals(b_int(1), b_short(1) !* p_short(1))
    assertEquals(b_int(-1), b_short(1) !* p_short(-1))
    assertEquals(b_int(23), b_short(1) !* p_short(23))
    assertEquals(b_int(-32), b_short(1) !* p_short(-32))
    assertEquals(b_int(32767), b_short(1) !* p_short(Short.MAX_VALUE))
    assertEquals(b_int(-32768), b_short(1) !* p_short(Short.MIN_VALUE))

    assertEquals(b_int(0), b_short(-1) !* p_short(0))
    assertEquals(b_int(-1), b_short(-1) !* p_short(1))
    assertEquals(b_int(1), b_short(-1) !* p_short(-1))
    assertEquals(b_int(-23), b_short(-1) !* p_short(23))
    assertEquals(b_int(32), b_short(-1) !* p_short(-32))
    assertEquals(b_int(-32767), b_short(-1) !* p_short(Short.MAX_VALUE))
    assertEquals(b_int(32768), b_short(-1) !* p_short(Short.MIN_VALUE))

    assertEquals(b_int(0), b_short(23) !* p_short(0))
    assertEquals(b_int(23), b_short(23) !* p_short(1))
    assertEquals(b_int(-23), b_short(23) !* p_short(-1))
    assertEquals(b_int(529), b_short(23) !* p_short(23))
    assertEquals(b_int(-736), b_short(23) !* p_short(-32))
    assertEquals(b_int(753641), b_short(23) !* p_short(Short.MAX_VALUE))
    assertEquals(b_int(-753664), b_short(23) !* p_short(Short.MIN_VALUE))

    assertEquals(b_int(0), b_short(-32) !* p_short(0))
    assertEquals(b_int(-32), b_short(-32) !* p_short(1))
    assertEquals(b_int(32), b_short(-32) !* p_short(-1))
    assertEquals(b_int(-736), b_short(-32) !* p_short(23))
    assertEquals(b_int(1024), b_short(-32) !* p_short(-32))
    assertEquals(b_int(-1048544), b_short(-32) !* p_short(Short.MAX_VALUE))
    assertEquals(b_int(1048576), b_short(-32) !* p_short(Short.MIN_VALUE))

    assertEquals(b_int(0), b_short(Short.MAX_VALUE) !* p_short(0))
    assertEquals(b_int(32767), b_short(Short.MAX_VALUE) !* p_short(1))
    assertEquals(b_int(-32767), b_short(Short.MAX_VALUE) !* p_short(-1))
    assertEquals(b_int(753641), b_short(Short.MAX_VALUE) !* p_short(23))
    assertEquals(b_int(-1048544), b_short(Short.MAX_VALUE) !* p_short(-32))
    assertEquals(b_int(1073676289), b_short(Short.MAX_VALUE) !* p_short(Short.MAX_VALUE))
    assertEquals(b_int(-1073709056), b_short(Short.MAX_VALUE) !* p_short(Short.MIN_VALUE))

    assertEquals(b_int(0), b_short(Short.MIN_VALUE) !* p_short(0))
    assertEquals(b_int(-32768), b_short(Short.MIN_VALUE) !* p_short(1))
    assertEquals(b_int(32768), b_short(Short.MIN_VALUE) !* p_short(-1))
    assertEquals(b_int(-753664), b_short(Short.MIN_VALUE) !* p_short(23))
    assertEquals(b_int(1048576), b_short(Short.MIN_VALUE) !* p_short(-32))
    assertEquals(b_int(-1073709056), b_short(Short.MIN_VALUE) !* p_short(Short.MAX_VALUE))
    assertEquals(b_int(1073741824), b_short(Short.MIN_VALUE) !* p_short(Short.MIN_VALUE))

    assertEquals(Integer, statictypeof(b_short(0) !* p_short(0)))
  }

  function testShortShortMultiplication() {
    assertEquals(b_int(0), b_short(0) !* b_short(0))
    assertEquals(b_int(0), b_short(0) !* b_short(1))
    assertEquals(b_int(0), b_short(0) !* b_short(-1))
    assertEquals(b_int(0), b_short(0) !* b_short(23))
    assertEquals(b_int(0), b_short(0) !* b_short(-32))
    assertEquals(b_int(0), b_short(0) !* b_short(Short.MAX_VALUE))
    assertEquals(b_int(0), b_short(0) !* b_short(Short.MIN_VALUE))

    assertEquals(b_int(0), b_short(1) !* b_short(0))
    assertEquals(b_int(1), b_short(1) !* b_short(1))
    assertEquals(b_int(-1), b_short(1) !* b_short(-1))
    assertEquals(b_int(23), b_short(1) !* b_short(23))
    assertEquals(b_int(-32), b_short(1) !* b_short(-32))
    assertEquals(b_int(32767), b_short(1) !* b_short(Short.MAX_VALUE))
    assertEquals(b_int(-32768), b_short(1) !* b_short(Short.MIN_VALUE))

    assertEquals(b_int(0), b_short(-1) !* b_short(0))
    assertEquals(b_int(-1), b_short(-1) !* b_short(1))
    assertEquals(b_int(1), b_short(-1) !* b_short(-1))
    assertEquals(b_int(-23), b_short(-1) !* b_short(23))
    assertEquals(b_int(32), b_short(-1) !* b_short(-32))
    assertEquals(b_int(-32767), b_short(-1) !* b_short(Short.MAX_VALUE))
    assertEquals(b_int(32768), b_short(-1) !* b_short(Short.MIN_VALUE))

    assertEquals(b_int(0), b_short(23) !* b_short(0))
    assertEquals(b_int(23), b_short(23) !* b_short(1))
    assertEquals(b_int(-23), b_short(23) !* b_short(-1))
    assertEquals(b_int(529), b_short(23) !* b_short(23))
    assertEquals(b_int(-736), b_short(23) !* b_short(-32))
    assertEquals(b_int(753641), b_short(23) !* b_short(Short.MAX_VALUE))
    assertEquals(b_int(-753664), b_short(23) !* b_short(Short.MIN_VALUE))

    assertEquals(b_int(0), b_short(-32) !* b_short(0))
    assertEquals(b_int(-32), b_short(-32) !* b_short(1))
    assertEquals(b_int(32), b_short(-32) !* b_short(-1))
    assertEquals(b_int(-736), b_short(-32) !* b_short(23))
    assertEquals(b_int(1024), b_short(-32) !* b_short(-32))
    assertEquals(b_int(-1048544), b_short(-32) !* b_short(Short.MAX_VALUE))
    assertEquals(b_int(1048576), b_short(-32) !* b_short(Short.MIN_VALUE))

    assertEquals(b_int(0), b_short(Short.MAX_VALUE) !* b_short(0))
    assertEquals(b_int(32767), b_short(Short.MAX_VALUE) !* b_short(1))
    assertEquals(b_int(-32767), b_short(Short.MAX_VALUE) !* b_short(-1))
    assertEquals(b_int(753641), b_short(Short.MAX_VALUE) !* b_short(23))
    assertEquals(b_int(-1048544), b_short(Short.MAX_VALUE) !* b_short(-32))
    assertEquals(b_int(1073676289), b_short(Short.MAX_VALUE) !* b_short(Short.MAX_VALUE))
    assertEquals(b_int(-1073709056), b_short(Short.MAX_VALUE) !* b_short(Short.MIN_VALUE))

    assertEquals(b_int(0), b_short(Short.MIN_VALUE) !* b_short(0))
    assertEquals(b_int(-32768), b_short(Short.MIN_VALUE) !* b_short(1))
    assertEquals(b_int(32768), b_short(Short.MIN_VALUE) !* b_short(-1))
    assertEquals(b_int(-753664), b_short(Short.MIN_VALUE) !* b_short(23))
    assertEquals(b_int(1048576), b_short(Short.MIN_VALUE) !* b_short(-32))
    assertEquals(b_int(-1073709056), b_short(Short.MIN_VALUE) !* b_short(Short.MAX_VALUE))
    assertEquals(b_int(1073741824), b_short(Short.MIN_VALUE) !* b_short(Short.MIN_VALUE))

    assertEquals(Integer, statictypeof(b_short(0) !* b_short(0)))
  }

  function testShortPCharMultiplication() {
    assertEquals(b_int(0), b_short(0) !* p_char(0))
    assertEquals(b_int(0), b_short(0) !* p_char(1))
    assertEquals(b_int(0), b_short(0) !* p_char(23))
    assertEquals(b_int(0), b_short(0) !* p_char(Character.MAX_VALUE))

    assertEquals(b_int(0), b_short(1) !* p_char(0))
    assertEquals(b_int(1), b_short(1) !* p_char(1))
    assertEquals(b_int(23), b_short(1) !* p_char(23))
    assertEquals(b_int(65535), b_short(1) !* p_char(Character.MAX_VALUE))

    assertEquals(b_int(0), b_short(-1) !* p_char(0))
    assertEquals(b_int(-1), b_short(-1) !* p_char(1))
    assertEquals(b_int(-23), b_short(-1) !* p_char(23))
    assertEquals(b_int(-65535), b_short(-1) !* p_char(Character.MAX_VALUE))

    assertEquals(b_int(0), b_short(23) !* p_char(0))
    assertEquals(b_int(23), b_short(23) !* p_char(1))
    assertEquals(b_int(529), b_short(23) !* p_char(23))
    assertEquals(b_int(1507305), b_short(23) !* p_char(Character.MAX_VALUE))

    assertEquals(b_int(0), b_short(-32) !* p_char(0))
    assertEquals(b_int(-32), b_short(-32) !* p_char(1))
    assertEquals(b_int(-736), b_short(-32) !* p_char(23))
    assertEquals(b_int(-2097120), b_short(-32) !* p_char(Character.MAX_VALUE))

    assertEquals(b_int(0), b_short(Short.MAX_VALUE) !* p_char(0))
    assertEquals(b_int(32767), b_short(Short.MAX_VALUE) !* p_char(1))
    assertEquals(b_int(753641), b_short(Short.MAX_VALUE) !* p_char(23))
    assertEquals(b_int(2147385345), b_short(Short.MAX_VALUE) !* p_char(Character.MAX_VALUE))

    assertEquals(b_int(0), b_short(Short.MIN_VALUE) !* p_char(0))
    assertEquals(b_int(-32768), b_short(Short.MIN_VALUE) !* p_char(1))
    assertEquals(b_int(-753664), b_short(Short.MIN_VALUE) !* p_char(23))
    assertEquals(b_int(-2147450880), b_short(Short.MIN_VALUE) !* p_char(Character.MAX_VALUE))

    assertEquals(Integer, statictypeof(b_short(0) !* p_char(0)))
  }

  function testShortCharacterMultiplication() {
    assertEquals(b_int(0), b_short(0) !* b_char(0))
    assertEquals(b_int(0), b_short(0) !* b_char(1))
    assertEquals(b_int(0), b_short(0) !* b_char(23))
    assertEquals(b_int(0), b_short(0) !* b_char(Character.MAX_VALUE))

    assertEquals(b_int(0), b_short(1) !* b_char(0))
    assertEquals(b_int(1), b_short(1) !* b_char(1))
    assertEquals(b_int(23), b_short(1) !* b_char(23))
    assertEquals(b_int(65535), b_short(1) !* b_char(Character.MAX_VALUE))

    assertEquals(b_int(0), b_short(-1) !* b_char(0))
    assertEquals(b_int(-1), b_short(-1) !* b_char(1))
    assertEquals(b_int(-23), b_short(-1) !* b_char(23))
    assertEquals(b_int(-65535), b_short(-1) !* b_char(Character.MAX_VALUE))

    assertEquals(b_int(0), b_short(23) !* b_char(0))
    assertEquals(b_int(23), b_short(23) !* b_char(1))
    assertEquals(b_int(529), b_short(23) !* b_char(23))
    assertEquals(b_int(1507305), b_short(23) !* b_char(Character.MAX_VALUE))

    assertEquals(b_int(0), b_short(-32) !* b_char(0))
    assertEquals(b_int(-32), b_short(-32) !* b_char(1))
    assertEquals(b_int(-736), b_short(-32) !* b_char(23))
    assertEquals(b_int(-2097120), b_short(-32) !* b_char(Character.MAX_VALUE))

    assertEquals(b_int(0), b_short(Short.MAX_VALUE) !* b_char(0))
    assertEquals(b_int(32767), b_short(Short.MAX_VALUE) !* b_char(1))
    assertEquals(b_int(753641), b_short(Short.MAX_VALUE) !* b_char(23))
    assertEquals(b_int(2147385345), b_short(Short.MAX_VALUE) !* b_char(Character.MAX_VALUE))

    assertEquals(b_int(0), b_short(Short.MIN_VALUE) !* b_char(0))
    assertEquals(b_int(-32768), b_short(Short.MIN_VALUE) !* b_char(1))
    assertEquals(b_int(-753664), b_short(Short.MIN_VALUE) !* b_char(23))
    assertEquals(b_int(-2147450880), b_short(Short.MIN_VALUE) !* b_char(Character.MAX_VALUE))

    assertEquals(Integer, statictypeof(b_short(0) !* b_char(0)))
  }

  function testShortPIntMultiplication() {
    assertEquals(b_int(0), b_short(0) !* p_int(0))
    assertEquals(b_int(0), b_short(0) !* p_int(1))
    assertEquals(b_int(0), b_short(0) !* p_int(-1))
    assertEquals(b_int(0), b_short(0) !* p_int(23))
    assertEquals(b_int(0), b_short(0) !* p_int(-32))
    assertEquals(b_int(0), b_short(0) !* p_int(Integer.MAX_VALUE))
    assertEquals(b_int(0), b_short(0) !* p_int(Integer.MIN_VALUE))

    assertEquals(b_int(0), b_short(1) !* p_int(0))
    assertEquals(b_int(1), b_short(1) !* p_int(1))
    assertEquals(b_int(-1), b_short(1) !* p_int(-1))
    assertEquals(b_int(23), b_short(1) !* p_int(23))
    assertEquals(b_int(-32), b_short(1) !* p_int(-32))
    assertEquals(b_int(2147483647), b_short(1) !* p_int(Integer.MAX_VALUE))
    assertEquals(b_int(-2147483648), b_short(1) !* p_int(Integer.MIN_VALUE))

    assertEquals(b_int(0), b_short(-1) !* p_int(0))
    assertEquals(b_int(-1), b_short(-1) !* p_int(1))
    assertEquals(b_int(1), b_short(-1) !* p_int(-1))
    assertEquals(b_int(-23), b_short(-1) !* p_int(23))
    assertEquals(b_int(32), b_short(-1) !* p_int(-32))
    assertEquals(b_int(-2147483647), b_short(-1) !* p_int(Integer.MAX_VALUE))
    assertEquals(b_int(-2147483648), b_short(-1) !* p_int(Integer.MIN_VALUE))

    assertEquals(b_int(0), b_short(23) !* p_int(0))
    assertEquals(b_int(23), b_short(23) !* p_int(1))
    assertEquals(b_int(-23), b_short(23) !* p_int(-1))
    assertEquals(b_int(529), b_short(23) !* p_int(23))
    assertEquals(b_int(-736), b_short(23) !* p_int(-32))
    assertEquals(b_int(2147483625), b_short(23) !* p_int(Integer.MAX_VALUE))
    assertEquals(b_int(-2147483648), b_short(23) !* p_int(Integer.MIN_VALUE))

    assertEquals(b_int(0), b_short(-32) !* p_int(0))
    assertEquals(b_int(-32), b_short(-32) !* p_int(1))
    assertEquals(b_int(32), b_short(-32) !* p_int(-1))
    assertEquals(b_int(-736), b_short(-32) !* p_int(23))
    assertEquals(b_int(1024), b_short(-32) !* p_int(-32))
    assertEquals(b_int(32), b_short(-32) !* p_int(Integer.MAX_VALUE))
    assertEquals(b_int(0), b_short(-32) !* p_int(Integer.MIN_VALUE))

    assertEquals(b_int(0), b_short(Short.MAX_VALUE) !* p_int(0))
    assertEquals(b_int(32767), b_short(Short.MAX_VALUE) !* p_int(1))
    assertEquals(b_int(-32767), b_short(Short.MAX_VALUE) !* p_int(-1))
    assertEquals(b_int(753641), b_short(Short.MAX_VALUE) !* p_int(23))
    assertEquals(b_int(-1048544), b_short(Short.MAX_VALUE) !* p_int(-32))
    assertEquals(b_int(2147450881), b_short(Short.MAX_VALUE) !* p_int(Integer.MAX_VALUE))
    assertEquals(b_int(-2147483648), b_short(Short.MAX_VALUE) !* p_int(Integer.MIN_VALUE))

    assertEquals(b_int(0), b_short(Short.MIN_VALUE) !* p_int(0))
    assertEquals(b_int(-32768), b_short(Short.MIN_VALUE) !* p_int(1))
    assertEquals(b_int(32768), b_short(Short.MIN_VALUE) !* p_int(-1))
    assertEquals(b_int(-753664), b_short(Short.MIN_VALUE) !* p_int(23))
    assertEquals(b_int(1048576), b_short(Short.MIN_VALUE) !* p_int(-32))
    assertEquals(b_int(32768), b_short(Short.MIN_VALUE) !* p_int(Integer.MAX_VALUE))
    assertEquals(b_int(0), b_short(Short.MIN_VALUE) !* p_int(Integer.MIN_VALUE))

    assertEquals(Integer, statictypeof(b_short(0) !* p_int(0)))
  }

  function testShortIntegerMultiplication() {
    assertEquals(b_int(0), b_short(0) !* b_int(0))
    assertEquals(b_int(0), b_short(0) !* b_int(1))
    assertEquals(b_int(0), b_short(0) !* b_int(-1))
    assertEquals(b_int(0), b_short(0) !* b_int(23))
    assertEquals(b_int(0), b_short(0) !* b_int(-32))
    assertEquals(b_int(0), b_short(0) !* b_int(Integer.MAX_VALUE))
    assertEquals(b_int(0), b_short(0) !* b_int(Integer.MIN_VALUE))

    assertEquals(b_int(0), b_short(1) !* b_int(0))
    assertEquals(b_int(1), b_short(1) !* b_int(1))
    assertEquals(b_int(-1), b_short(1) !* b_int(-1))
    assertEquals(b_int(23), b_short(1) !* b_int(23))
    assertEquals(b_int(-32), b_short(1) !* b_int(-32))
    assertEquals(b_int(2147483647), b_short(1) !* b_int(Integer.MAX_VALUE))
    assertEquals(b_int(-2147483648), b_short(1) !* b_int(Integer.MIN_VALUE))

    assertEquals(b_int(0), b_short(-1) !* b_int(0))
    assertEquals(b_int(-1), b_short(-1) !* b_int(1))
    assertEquals(b_int(1), b_short(-1) !* b_int(-1))
    assertEquals(b_int(-23), b_short(-1) !* b_int(23))
    assertEquals(b_int(32), b_short(-1) !* b_int(-32))
    assertEquals(b_int(-2147483647), b_short(-1) !* b_int(Integer.MAX_VALUE))
    assertEquals(b_int(-2147483648), b_short(-1) !* b_int(Integer.MIN_VALUE))

    assertEquals(b_int(0), b_short(23) !* b_int(0))
    assertEquals(b_int(23), b_short(23) !* b_int(1))
    assertEquals(b_int(-23), b_short(23) !* b_int(-1))
    assertEquals(b_int(529), b_short(23) !* b_int(23))
    assertEquals(b_int(-736), b_short(23) !* b_int(-32))
    assertEquals(b_int(2147483625), b_short(23) !* b_int(Integer.MAX_VALUE))
    assertEquals(b_int(-2147483648), b_short(23) !* b_int(Integer.MIN_VALUE))

    assertEquals(b_int(0), b_short(-32) !* b_int(0))
    assertEquals(b_int(-32), b_short(-32) !* b_int(1))
    assertEquals(b_int(32), b_short(-32) !* b_int(-1))
    assertEquals(b_int(-736), b_short(-32) !* b_int(23))
    assertEquals(b_int(1024), b_short(-32) !* b_int(-32))
    assertEquals(b_int(32), b_short(-32) !* b_int(Integer.MAX_VALUE))
    assertEquals(b_int(0), b_short(-32) !* b_int(Integer.MIN_VALUE))

    assertEquals(b_int(0), b_short(Short.MAX_VALUE) !* b_int(0))
    assertEquals(b_int(32767), b_short(Short.MAX_VALUE) !* b_int(1))
    assertEquals(b_int(-32767), b_short(Short.MAX_VALUE) !* b_int(-1))
    assertEquals(b_int(753641), b_short(Short.MAX_VALUE) !* b_int(23))
    assertEquals(b_int(-1048544), b_short(Short.MAX_VALUE) !* b_int(-32))
    assertEquals(b_int(2147450881), b_short(Short.MAX_VALUE) !* b_int(Integer.MAX_VALUE))
    assertEquals(b_int(-2147483648), b_short(Short.MAX_VALUE) !* b_int(Integer.MIN_VALUE))

    assertEquals(b_int(0), b_short(Short.MIN_VALUE) !* b_int(0))
    assertEquals(b_int(-32768), b_short(Short.MIN_VALUE) !* b_int(1))
    assertEquals(b_int(32768), b_short(Short.MIN_VALUE) !* b_int(-1))
    assertEquals(b_int(-753664), b_short(Short.MIN_VALUE) !* b_int(23))
    assertEquals(b_int(1048576), b_short(Short.MIN_VALUE) !* b_int(-32))
    assertEquals(b_int(32768), b_short(Short.MIN_VALUE) !* b_int(Integer.MAX_VALUE))
    assertEquals(b_int(0), b_short(Short.MIN_VALUE) !* b_int(Integer.MIN_VALUE))

    assertEquals(Integer, statictypeof(b_short(0) !* b_int(0)))
  }

  function testShortPLongMultiplication() {
    assertEquals(b_long(0), b_short(0) !* p_long(0))
    assertEquals(b_long(0), b_short(0) !* p_long(1))
    assertEquals(b_long(0), b_short(0) !* p_long(-1))
    assertEquals(b_long(0), b_short(0) !* p_long(23))
    assertEquals(b_long(0), b_short(0) !* p_long(-32))
    assertEquals(b_long(0), b_short(0) !* p_long(Long.MAX_VALUE))
    assertEquals(b_long(0), b_short(0) !* p_long(Long.MIN_VALUE))

    assertEquals(b_long(0), b_short(1) !* p_long(0))
    assertEquals(b_long(1), b_short(1) !* p_long(1))
    assertEquals(b_long(-1), b_short(1) !* p_long(-1))
    assertEquals(b_long(23), b_short(1) !* p_long(23))
    assertEquals(b_long(-32), b_short(1) !* p_long(-32))
    assertEquals(b_long(9223372036854775807), b_short(1) !* p_long(Long.MAX_VALUE))
    assertEquals(b_long(-9223372036854775808), b_short(1) !* p_long(Long.MIN_VALUE))

    assertEquals(b_long(0), b_short(-1) !* p_long(0))
    assertEquals(b_long(-1), b_short(-1) !* p_long(1))
    assertEquals(b_long(1), b_short(-1) !* p_long(-1))
    assertEquals(b_long(-23), b_short(-1) !* p_long(23))
    assertEquals(b_long(32), b_short(-1) !* p_long(-32))
    assertEquals(b_long(-9223372036854775807), b_short(-1) !* p_long(Long.MAX_VALUE))
    assertEquals(b_long(-9223372036854775808), b_short(-1) !* p_long(Long.MIN_VALUE))

    assertEquals(b_long(0), b_short(23) !* p_long(0))
    assertEquals(b_long(23), b_short(23) !* p_long(1))
    assertEquals(b_long(-23), b_short(23) !* p_long(-1))
    assertEquals(b_long(529), b_short(23) !* p_long(23))
    assertEquals(b_long(-736), b_short(23) !* p_long(-32))
    assertEquals(b_long(9223372036854775785), b_short(23) !* p_long(Long.MAX_VALUE))
    assertEquals(b_long(-9223372036854775808), b_short(23) !* p_long(Long.MIN_VALUE))

    assertEquals(b_long(0), b_short(-32) !* p_long(0))
    assertEquals(b_long(-32), b_short(-32) !* p_long(1))
    assertEquals(b_long(32), b_short(-32) !* p_long(-1))
    assertEquals(b_long(-736), b_short(-32) !* p_long(23))
    assertEquals(b_long(1024), b_short(-32) !* p_long(-32))
    assertEquals(b_long(32), b_short(-32) !* p_long(Long.MAX_VALUE))
    assertEquals(b_long(0), b_short(-32) !* p_long(Long.MIN_VALUE))

    assertEquals(b_long(0), b_short(Short.MAX_VALUE) !* p_long(0))
    assertEquals(b_long(32767), b_short(Short.MAX_VALUE) !* p_long(1))
    assertEquals(b_long(-32767), b_short(Short.MAX_VALUE) !* p_long(-1))
    assertEquals(b_long(753641), b_short(Short.MAX_VALUE) !* p_long(23))
    assertEquals(b_long(-1048544), b_short(Short.MAX_VALUE) !* p_long(-32))
    assertEquals(b_long(9223372036854743041), b_short(Short.MAX_VALUE) !* p_long(Long.MAX_VALUE))
    assertEquals(b_long(-9223372036854775808), b_short(Short.MAX_VALUE) !* p_long(Long.MIN_VALUE))

    assertEquals(b_long(0), b_short(Short.MIN_VALUE) !* p_long(0))
    assertEquals(b_long(-32768), b_short(Short.MIN_VALUE) !* p_long(1))
    assertEquals(b_long(32768), b_short(Short.MIN_VALUE) !* p_long(-1))
    assertEquals(b_long(-753664), b_short(Short.MIN_VALUE) !* p_long(23))
    assertEquals(b_long(1048576), b_short(Short.MIN_VALUE) !* p_long(-32))
    assertEquals(b_long(32768), b_short(Short.MIN_VALUE) !* p_long(Long.MAX_VALUE))
    assertEquals(b_long(0), b_short(Short.MIN_VALUE) !* p_long(Long.MIN_VALUE))

    assertEquals(Long, statictypeof(b_short(0) !* p_long(0)))
  }

  function testShortLongMultiplication() {
    assertEquals(b_long(0), b_short(0) !* b_long(0))
    assertEquals(b_long(0), b_short(0) !* b_long(1))
    assertEquals(b_long(0), b_short(0) !* b_long(-1))
    assertEquals(b_long(0), b_short(0) !* b_long(23))
    assertEquals(b_long(0), b_short(0) !* b_long(-32))
    assertEquals(b_long(0), b_short(0) !* b_long(Long.MAX_VALUE))
    assertEquals(b_long(0), b_short(0) !* b_long(Long.MIN_VALUE))

    assertEquals(b_long(0), b_short(1) !* b_long(0))
    assertEquals(b_long(1), b_short(1) !* b_long(1))
    assertEquals(b_long(-1), b_short(1) !* b_long(-1))
    assertEquals(b_long(23), b_short(1) !* b_long(23))
    assertEquals(b_long(-32), b_short(1) !* b_long(-32))
    assertEquals(b_long(9223372036854775807), b_short(1) !* b_long(Long.MAX_VALUE))
    assertEquals(b_long(-9223372036854775808), b_short(1) !* b_long(Long.MIN_VALUE))

    assertEquals(b_long(0), b_short(-1) !* b_long(0))
    assertEquals(b_long(-1), b_short(-1) !* b_long(1))
    assertEquals(b_long(1), b_short(-1) !* b_long(-1))
    assertEquals(b_long(-23), b_short(-1) !* b_long(23))
    assertEquals(b_long(32), b_short(-1) !* b_long(-32))
    assertEquals(b_long(-9223372036854775807), b_short(-1) !* b_long(Long.MAX_VALUE))
    assertEquals(b_long(-9223372036854775808), b_short(-1) !* b_long(Long.MIN_VALUE))

    assertEquals(b_long(0), b_short(23) !* b_long(0))
    assertEquals(b_long(23), b_short(23) !* b_long(1))
    assertEquals(b_long(-23), b_short(23) !* b_long(-1))
    assertEquals(b_long(529), b_short(23) !* b_long(23))
    assertEquals(b_long(-736), b_short(23) !* b_long(-32))
    assertEquals(b_long(9223372036854775785), b_short(23) !* b_long(Long.MAX_VALUE))
    assertEquals(b_long(-9223372036854775808), b_short(23) !* b_long(Long.MIN_VALUE))

    assertEquals(b_long(0), b_short(-32) !* b_long(0))
    assertEquals(b_long(-32), b_short(-32) !* b_long(1))
    assertEquals(b_long(32), b_short(-32) !* b_long(-1))
    assertEquals(b_long(-736), b_short(-32) !* b_long(23))
    assertEquals(b_long(1024), b_short(-32) !* b_long(-32))
    assertEquals(b_long(32), b_short(-32) !* b_long(Long.MAX_VALUE))
    assertEquals(b_long(0), b_short(-32) !* b_long(Long.MIN_VALUE))

    assertEquals(b_long(0), b_short(Short.MAX_VALUE) !* b_long(0))
    assertEquals(b_long(32767), b_short(Short.MAX_VALUE) !* b_long(1))
    assertEquals(b_long(-32767), b_short(Short.MAX_VALUE) !* b_long(-1))
    assertEquals(b_long(753641), b_short(Short.MAX_VALUE) !* b_long(23))
    assertEquals(b_long(-1048544), b_short(Short.MAX_VALUE) !* b_long(-32))
    assertEquals(b_long(9223372036854743041), b_short(Short.MAX_VALUE) !* b_long(Long.MAX_VALUE))
    assertEquals(b_long(-9223372036854775808), b_short(Short.MAX_VALUE) !* b_long(Long.MIN_VALUE))

    assertEquals(b_long(0), b_short(Short.MIN_VALUE) !* b_long(0))
    assertEquals(b_long(-32768), b_short(Short.MIN_VALUE) !* b_long(1))
    assertEquals(b_long(32768), b_short(Short.MIN_VALUE) !* b_long(-1))
    assertEquals(b_long(-753664), b_short(Short.MIN_VALUE) !* b_long(23))
    assertEquals(b_long(1048576), b_short(Short.MIN_VALUE) !* b_long(-32))
    assertEquals(b_long(32768), b_short(Short.MIN_VALUE) !* b_long(Long.MAX_VALUE))
    assertEquals(b_long(0), b_short(Short.MIN_VALUE) !* b_long(Long.MIN_VALUE))

    assertEquals(Long, statictypeof(b_short(0) !* b_long(0)))
  }

  function testShortPFloatMultiplication() {
    assertEquals(b_float(0.0), b_short(0) * p_float(0.0))
    assertEquals(b_float(0.0), b_short(0) * p_float(1.0))
    assertEquals(b_float(-0.0), b_short(0) * p_float(-1.0))
    assertEquals(b_float(0.0), b_short(0) * p_float(23.0))
    assertEquals(b_float(0.0), b_short(0) * p_float(23.123))
    assertEquals(b_float(-0.0), b_short(0) * p_float(-32.0))
    assertEquals(b_float(-0.0), b_short(0) * p_float(-32.456))
    assertEquals(b_float(Float.NaN_), b_short(0) * p_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(0) * p_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(0) * p_float(Float.NaN_))
    assertEquals(b_float(0.0), b_short(0) * p_float(Float.MAX_VALUE))
    assertEquals(b_float(0.0), b_short(0) * p_float(Float.MIN_VALUE))

    assertEquals(b_float(0.0), b_short(1) * p_float(0.0))
    assertEquals(b_float(1.0), b_short(1) * p_float(1.0))
    assertEquals(b_float(-1.0), b_short(1) * p_float(-1.0))
    assertEquals(b_float(23.0), b_short(1) * p_float(23.0))
    assertEquals(b_float(23.123), b_short(1) * p_float(23.123))
    assertEquals(b_float(-32.0), b_short(1) * p_float(-32.0))
    assertEquals(b_float(-32.456), b_short(1) * p_float(-32.456))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(1) * p_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(1) * p_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(1) * p_float(Float.NaN_))
    assertEquals(b_float(Float.parseFloat("3.4028235E38")), b_short(1) * p_float(Float.MAX_VALUE))
    assertEquals(b_float(Float.parseFloat("1.4E-45")), b_short(1) * p_float(Float.MIN_VALUE))

    assertEquals(b_float(-0.0), b_short(-1) * p_float(0.0))
    assertEquals(b_float(-1.0), b_short(-1) * p_float(1.0))
    assertEquals(b_float(1.0), b_short(-1) * p_float(-1.0))
    assertEquals(b_float(-23.0), b_short(-1) * p_float(23.0))
    assertEquals(b_float(-23.123), b_short(-1) * p_float(23.123))
    assertEquals(b_float(32.0), b_short(-1) * p_float(-32.0))
    assertEquals(b_float(32.456), b_short(-1) * p_float(-32.456))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(-1) * p_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(-1) * p_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(-1) * p_float(Float.NaN_))
    assertEquals(b_float(Float.parseFloat("-3.4028235E38")), b_short(-1) * p_float(Float.MAX_VALUE))
    assertEquals(b_float(Float.parseFloat("-1.4E-45")), b_short(-1) * p_float(Float.MIN_VALUE))

    assertEquals(b_float(0.0), b_short(23) * p_float(0.0))
    assertEquals(b_float(23.0), b_short(23) * p_float(1.0))
    assertEquals(b_float(-23.0), b_short(23) * p_float(-1.0))
    assertEquals(b_float(529.0), b_short(23) * p_float(23.0))
    assertEquals(b_float(531.829), b_short(23) * p_float(23.123))
    assertEquals(b_float(-736.0), b_short(23) * p_float(-32.0))
    assertEquals(b_float(-746.48804), b_short(23) * p_float(-32.456))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(23) * p_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(23) * p_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(23) * p_float(Float.NaN_))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(23) * p_float(Float.MAX_VALUE))
    assertEquals(b_float(Float.parseFloat("3.2E-44")), b_short(23) * p_float(Float.MIN_VALUE))

    assertEquals(b_float(-0.0), b_short(-32) * p_float(0.0))
    assertEquals(b_float(-32.0), b_short(-32) * p_float(1.0))
    assertEquals(b_float(32.0), b_short(-32) * p_float(-1.0))
    assertEquals(b_float(-736.0), b_short(-32) * p_float(23.0))
    assertEquals(b_float(-739.936), b_short(-32) * p_float(23.123))
    assertEquals(b_float(1024.0), b_short(-32) * p_float(-32.0))
    assertEquals(b_float(1038.592), b_short(-32) * p_float(-32.456))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(-32) * p_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(-32) * p_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(-32) * p_float(Float.NaN_))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(-32) * p_float(Float.MAX_VALUE))
    assertEquals(b_float(Float.parseFloat("-4.5E-44")), b_short(-32) * p_float(Float.MIN_VALUE))

    assertEquals(b_float(0.0), b_short(Short.MAX_VALUE) * p_float(0.0))
    assertEquals(b_float(32767.0), b_short(Short.MAX_VALUE) * p_float(1.0))
    assertEquals(b_float(-32767.0), b_short(Short.MAX_VALUE) * p_float(-1.0))
    assertEquals(b_float(753641.0), b_short(Short.MAX_VALUE) * p_float(23.0))
    assertEquals(b_float(757671.3), b_short(Short.MAX_VALUE) * p_float(23.123))
    assertEquals(b_float(-1048544.0), b_short(Short.MAX_VALUE) * p_float(-32.0))
    assertEquals(b_float(-1063485.8), b_short(Short.MAX_VALUE) * p_float(-32.456))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(Short.MAX_VALUE) * p_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(Short.MAX_VALUE) * p_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(Short.MAX_VALUE) * p_float(Float.NaN_))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(Short.MAX_VALUE) * p_float(Float.MAX_VALUE))
    assertEquals(b_float(Float.parseFloat("4.5916E-41")), b_short(Short.MAX_VALUE) * p_float(Float.MIN_VALUE))

    assertEquals(b_float(-0.0), b_short(Short.MIN_VALUE) * p_float(0.0))
    assertEquals(b_float(-32768.0), b_short(Short.MIN_VALUE) * p_float(1.0))
    assertEquals(b_float(32768.0), b_short(Short.MIN_VALUE) * p_float(-1.0))
    assertEquals(b_float(-753664.0), b_short(Short.MIN_VALUE) * p_float(23.0))
    assertEquals(b_float(-757694.44), b_short(Short.MIN_VALUE) * p_float(23.123))
    assertEquals(b_float(1048576.0), b_short(Short.MIN_VALUE) * p_float(-32.0))
    assertEquals(b_float(1063518.2), b_short(Short.MIN_VALUE) * p_float(-32.456))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(Short.MIN_VALUE) * p_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(Short.MIN_VALUE) * p_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(Short.MIN_VALUE) * p_float(Float.NaN_))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(Short.MIN_VALUE) * p_float(Float.MAX_VALUE))
    assertEquals(b_float(Float.parseFloat("-4.5918E-41")), b_short(Short.MIN_VALUE) * p_float(Float.MIN_VALUE))

    assertEquals(Float, statictypeof(b_short(0) * p_float(0.0)))
  }

  function testShortFloatMultiplication() {
    assertEquals(b_float(0.0), b_short(0) * b_float(0.0))
    assertEquals(b_float(0.0), b_short(0) * b_float(1.0))
    assertEquals(b_float(-0.0), b_short(0) * b_float(-1.0))
    assertEquals(b_float(0.0), b_short(0) * b_float(23.0))
    assertEquals(b_float(0.0), b_short(0) * b_float(23.123))
    assertEquals(b_float(-0.0), b_short(0) * b_float(-32.0))
    assertEquals(b_float(-0.0), b_short(0) * b_float(-32.456))
    assertEquals(b_float(Float.NaN_), b_short(0) * b_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(0) * b_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(0) * b_float(Float.NaN_))
    assertEquals(b_float(0.0), b_short(0) * b_float(Float.MAX_VALUE))
    assertEquals(b_float(0.0), b_short(0) * b_float(Float.MIN_VALUE))

    assertEquals(b_float(0.0), b_short(1) * b_float(0.0))
    assertEquals(b_float(1.0), b_short(1) * b_float(1.0))
    assertEquals(b_float(-1.0), b_short(1) * b_float(-1.0))
    assertEquals(b_float(23.0), b_short(1) * b_float(23.0))
    assertEquals(b_float(23.123), b_short(1) * b_float(23.123))
    assertEquals(b_float(-32.0), b_short(1) * b_float(-32.0))
    assertEquals(b_float(-32.456), b_short(1) * b_float(-32.456))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(1) * b_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(1) * b_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(1) * b_float(Float.NaN_))
    assertEquals(b_float(Float.parseFloat("3.4028235E38")), b_short(1) * b_float(Float.MAX_VALUE))
    assertEquals(b_float(Float.parseFloat("1.4E-45")), b_short(1) * b_float(Float.MIN_VALUE))

    assertEquals(b_float(-0.0), b_short(-1) * b_float(0.0))
    assertEquals(b_float(-1.0), b_short(-1) * b_float(1.0))
    assertEquals(b_float(1.0), b_short(-1) * b_float(-1.0))
    assertEquals(b_float(-23.0), b_short(-1) * b_float(23.0))
    assertEquals(b_float(-23.123), b_short(-1) * b_float(23.123))
    assertEquals(b_float(32.0), b_short(-1) * b_float(-32.0))
    assertEquals(b_float(32.456), b_short(-1) * b_float(-32.456))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(-1) * b_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(-1) * b_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(-1) * b_float(Float.NaN_))
    assertEquals(b_float(Float.parseFloat("-3.4028235E38")), b_short(-1) * b_float(Float.MAX_VALUE))
    assertEquals(b_float(Float.parseFloat("-1.4E-45")), b_short(-1) * b_float(Float.MIN_VALUE))

    assertEquals(b_float(0.0), b_short(23) * b_float(0.0))
    assertEquals(b_float(23.0), b_short(23) * b_float(1.0))
    assertEquals(b_float(-23.0), b_short(23) * b_float(-1.0))
    assertEquals(b_float(529.0), b_short(23) * b_float(23.0))
    assertEquals(b_float(531.829), b_short(23) * b_float(23.123))
    assertEquals(b_float(-736.0), b_short(23) * b_float(-32.0))
    assertEquals(b_float(-746.48804), b_short(23) * b_float(-32.456))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(23) * b_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(23) * b_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(23) * b_float(Float.NaN_))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(23) * b_float(Float.MAX_VALUE))
    assertEquals(b_float(Float.parseFloat("3.2E-44")), b_short(23) * b_float(Float.MIN_VALUE))

    assertEquals(b_float(-0.0), b_short(-32) * b_float(0.0))
    assertEquals(b_float(-32.0), b_short(-32) * b_float(1.0))
    assertEquals(b_float(32.0), b_short(-32) * b_float(-1.0))
    assertEquals(b_float(-736.0), b_short(-32) * b_float(23.0))
    assertEquals(b_float(-739.936), b_short(-32) * b_float(23.123))
    assertEquals(b_float(1024.0), b_short(-32) * b_float(-32.0))
    assertEquals(b_float(1038.592), b_short(-32) * b_float(-32.456))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(-32) * b_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(-32) * b_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(-32) * b_float(Float.NaN_))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(-32) * b_float(Float.MAX_VALUE))
    assertEquals(b_float(Float.parseFloat("-4.5E-44")), b_short(-32) * b_float(Float.MIN_VALUE))

    assertEquals(b_float(0.0), b_short(Short.MAX_VALUE) * b_float(0.0))
    assertEquals(b_float(32767.0), b_short(Short.MAX_VALUE) * b_float(1.0))
    assertEquals(b_float(-32767.0), b_short(Short.MAX_VALUE) * b_float(-1.0))
    assertEquals(b_float(753641.0), b_short(Short.MAX_VALUE) * b_float(23.0))
    assertEquals(b_float(757671.3), b_short(Short.MAX_VALUE) * b_float(23.123))
    assertEquals(b_float(-1048544.0), b_short(Short.MAX_VALUE) * b_float(-32.0))
    assertEquals(b_float(-1063485.8), b_short(Short.MAX_VALUE) * b_float(-32.456))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(Short.MAX_VALUE) * b_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(Short.MAX_VALUE) * b_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(Short.MAX_VALUE) * b_float(Float.NaN_))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(Short.MAX_VALUE) * b_float(Float.MAX_VALUE))
    assertEquals(b_float(Float.parseFloat("4.5916E-41")), b_short(Short.MAX_VALUE) * b_float(Float.MIN_VALUE))

    assertEquals(b_float(-0.0), b_short(Short.MIN_VALUE) * b_float(0.0))
    assertEquals(b_float(-32768.0), b_short(Short.MIN_VALUE) * b_float(1.0))
    assertEquals(b_float(32768.0), b_short(Short.MIN_VALUE) * b_float(-1.0))
    assertEquals(b_float(-753664.0), b_short(Short.MIN_VALUE) * b_float(23.0))
    assertEquals(b_float(-757694.44), b_short(Short.MIN_VALUE) * b_float(23.123))
    assertEquals(b_float(1048576.0), b_short(Short.MIN_VALUE) * b_float(-32.0))
    assertEquals(b_float(1063518.2), b_short(Short.MIN_VALUE) * b_float(-32.456))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(Short.MIN_VALUE) * b_float(Float.POSITIVE_INFINITY))
    assertEquals(b_float(Float.POSITIVE_INFINITY), b_short(Short.MIN_VALUE) * b_float(Float.NEGATIVE_INFINITY))
    assertEquals(b_float(Float.NaN_), b_short(Short.MIN_VALUE) * b_float(Float.NaN_))
    assertEquals(b_float(Float.NEGATIVE_INFINITY), b_short(Short.MIN_VALUE) * b_float(Float.MAX_VALUE))
    assertEquals(b_float(Float.parseFloat("-4.5918E-41")), b_short(Short.MIN_VALUE) * b_float(Float.MIN_VALUE))

    assertEquals(Float, statictypeof(b_short(0) * b_float(0.0)))
  }

  function testShortPDoubleMultiplication() {
    assertEquals(b_double(0.0), b_short(0) * p_double(0.0))
    assertEquals(b_double(0.0), b_short(0) * p_double(1.0))
    assertEquals(b_double(-0.0), b_short(0) * p_double(-1.0))
    assertEquals(b_double(0.0), b_short(0) * p_double(23.0))
    assertEquals(b_double(0.0), b_short(0) * p_double(23.123))
    assertEquals(b_double(-0.0), b_short(0) * p_double(-32.0))
    assertEquals(b_double(-0.0), b_short(0) * p_double(-32.456))
    assertEquals(b_double(Double.NaN_), b_short(0) * p_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(0) * p_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(0) * p_double(Double.NaN_))
    assertEquals(b_double(0.0), b_short(0) * p_double(Double.MAX_VALUE))
    assertEquals(b_double(0.0), b_short(0) * p_double(Double.MIN_VALUE))

    assertEquals(b_double(0.0), b_short(1) * p_double(0.0))
    assertEquals(b_double(1.0), b_short(1) * p_double(1.0))
    assertEquals(b_double(-1.0), b_short(1) * p_double(-1.0))
    assertEquals(b_double(23.0), b_short(1) * p_double(23.0))
    assertEquals(b_double(23.123), b_short(1) * p_double(23.123))
    assertEquals(b_double(-32.0), b_short(1) * p_double(-32.0))
    assertEquals(b_double(-32.456), b_short(1) * p_double(-32.456))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(1) * p_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(1) * p_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(1) * p_double(Double.NaN_))
    assertEquals(b_double(Double.MAX_VALUE), b_short(1) * p_double(Double.MAX_VALUE))
    assertEquals(b_double(Double.MIN_VALUE), b_short(1) * p_double(Double.MIN_VALUE))

    assertEquals(b_double(-0.0), b_short(-1) * p_double(0.0))
    assertEquals(b_double(-1.0), b_short(-1) * p_double(1.0))
    assertEquals(b_double(1.0), b_short(-1) * p_double(-1.0))
    assertEquals(b_double(-23.0), b_short(-1) * p_double(23.0))
    assertEquals(b_double(-23.123), b_short(-1) * p_double(23.123))
    assertEquals(b_double(32.0), b_short(-1) * p_double(-32.0))
    assertEquals(b_double(32.456), b_short(-1) * p_double(-32.456))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(-1) * p_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(-1) * p_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(-1) * p_double(Double.NaN_))
    assertEquals(b_double(Double.parseDouble("-1.7976931348623157E308")), b_short(-1) * p_double(Double.MAX_VALUE))
    assertEquals(b_double(Double.parseDouble("-4.9E-324")), b_short(-1) * p_double(Double.MIN_VALUE))

    assertEquals(b_double(0.0), b_short(23) * p_double(0.0))
    assertEquals(b_double(23.0), b_short(23) * p_double(1.0))
    assertEquals(b_double(-23.0), b_short(23) * p_double(-1.0))
    assertEquals(b_double(529.0), b_short(23) * p_double(23.0))
    assertEquals(b_double(531.8290000000001), b_short(23) * p_double(23.123))
    assertEquals(b_double(-736.0), b_short(23) * p_double(-32.0))
    assertEquals(b_double(-746.488), b_short(23) * p_double(-32.456))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(23) * p_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(23) * p_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(23) * p_double(Double.NaN_))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(23) * p_double(Double.MAX_VALUE))
    assertEquals(b_double(Double.parseDouble("1.14E-322")), b_short(23) * p_double(Double.MIN_VALUE))

    assertEquals(b_double(-0.0), b_short(-32) * p_double(0.0))
    assertEquals(b_double(-32.0), b_short(-32) * p_double(1.0))
    assertEquals(b_double(32.0), b_short(-32) * p_double(-1.0))
    assertEquals(b_double(-736.0), b_short(-32) * p_double(23.0))
    assertEquals(b_double(-739.936), b_short(-32) * p_double(23.123))
    assertEquals(b_double(1024.0), b_short(-32) * p_double(-32.0))
    assertEquals(b_double(1038.592), b_short(-32) * p_double(-32.456))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(-32) * p_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(-32) * p_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(-32) * p_double(Double.NaN_))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(-32) * p_double(Double.MAX_VALUE))
    assertEquals(b_double(Double.parseDouble("-1.58E-322")), b_short(-32) * p_double(Double.MIN_VALUE))

    assertEquals(b_double(0.0), b_short(Short.MAX_VALUE) * p_double(0.0))
    assertEquals(b_double(32767.0), b_short(Short.MAX_VALUE) * p_double(1.0))
    assertEquals(b_double(-32767.0), b_short(Short.MAX_VALUE) * p_double(-1.0))
    assertEquals(b_double(753641.0), b_short(Short.MAX_VALUE) * p_double(23.0))
    assertEquals(b_double(757671.341), b_short(Short.MAX_VALUE) * p_double(23.123))
    assertEquals(b_double(-1048544.0), b_short(Short.MAX_VALUE) * p_double(-32.0))
    assertEquals(b_double(-1063485.752), b_short(Short.MAX_VALUE) * p_double(-32.456))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(Short.MAX_VALUE) * p_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(Short.MAX_VALUE) * p_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(Short.MAX_VALUE) * p_double(Double.NaN_))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(Short.MAX_VALUE) * p_double(Double.MAX_VALUE))
    assertEquals(b_double(Double.parseDouble("1.6189E-319")), b_short(Short.MAX_VALUE) * p_double(Double.MIN_VALUE))

    assertEquals(b_double(-0.0), b_short(Short.MIN_VALUE) * p_double(0.0))
    assertEquals(b_double(-32768.0), b_short(Short.MIN_VALUE) * p_double(1.0))
    assertEquals(b_double(32768.0), b_short(Short.MIN_VALUE) * p_double(-1.0))
    assertEquals(b_double(-753664.0), b_short(Short.MIN_VALUE) * p_double(23.0))
    assertEquals(b_double(-757694.464), b_short(Short.MIN_VALUE) * p_double(23.123))
    assertEquals(b_double(1048576.0), b_short(Short.MIN_VALUE) * p_double(-32.0))
    assertEquals(b_double(1063518.208), b_short(Short.MIN_VALUE) * p_double(-32.456))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(Short.MIN_VALUE) * p_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(Short.MIN_VALUE) * p_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(Short.MIN_VALUE) * p_double(Double.NaN_))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(Short.MIN_VALUE) * p_double(Double.MAX_VALUE))
    assertEquals(b_double(Double.parseDouble("-1.61895E-319")), b_short(Short.MIN_VALUE) * p_double(Double.MIN_VALUE))

    assertEquals(Double, statictypeof(b_short(0) * p_double(0.0)))
  }

  function testShortDoubleMultiplication() {
    assertEquals(b_double(0.0), b_short(0) * b_double(0.0))
    assertEquals(b_double(0.0), b_short(0) * b_double(1.0))
    assertEquals(b_double(-0.0), b_short(0) * b_double(-1.0))
    assertEquals(b_double(0.0), b_short(0) * b_double(23.0))
    assertEquals(b_double(0.0), b_short(0) * b_double(23.123))
    assertEquals(b_double(-0.0), b_short(0) * b_double(-32.0))
    assertEquals(b_double(-0.0), b_short(0) * b_double(-32.456))
    assertEquals(b_double(Double.NaN_), b_short(0) * b_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(0) * b_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(0) * b_double(Double.NaN_))
    assertEquals(b_double(0.0), b_short(0) * b_double(Double.MAX_VALUE))
    assertEquals(b_double(0.0), b_short(0) * b_double(Double.MIN_VALUE))

    assertEquals(b_double(0.0), b_short(1) * b_double(0.0))
    assertEquals(b_double(1.0), b_short(1) * b_double(1.0))
    assertEquals(b_double(-1.0), b_short(1) * b_double(-1.0))
    assertEquals(b_double(23.0), b_short(1) * b_double(23.0))
    assertEquals(b_double(23.123), b_short(1) * b_double(23.123))
    assertEquals(b_double(-32.0), b_short(1) * b_double(-32.0))
    assertEquals(b_double(-32.456), b_short(1) * b_double(-32.456))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(1) * b_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(1) * b_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(1) * b_double(Double.NaN_))
    assertEquals(b_double(Double.MAX_VALUE), b_short(1) * b_double(Double.MAX_VALUE))
    assertEquals(b_double(Double.MIN_VALUE), b_short(1) * b_double(Double.MIN_VALUE))

    assertEquals(b_double(-0.0), b_short(-1) * b_double(0.0))
    assertEquals(b_double(-1.0), b_short(-1) * b_double(1.0))
    assertEquals(b_double(1.0), b_short(-1) * b_double(-1.0))
    assertEquals(b_double(-23.0), b_short(-1) * b_double(23.0))
    assertEquals(b_double(-23.123), b_short(-1) * b_double(23.123))
    assertEquals(b_double(32.0), b_short(-1) * b_double(-32.0))
    assertEquals(b_double(32.456), b_short(-1) * b_double(-32.456))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(-1) * b_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(-1) * b_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(-1) * b_double(Double.NaN_))
    assertEquals(b_double(Double.parseDouble("-1.7976931348623157E308")), b_short(-1) * b_double(Double.MAX_VALUE))
    assertEquals(b_double(Double.parseDouble("-4.9E-324")), b_short(-1) * b_double(Double.MIN_VALUE))

    assertEquals(b_double(0.0), b_short(23) * b_double(0.0))
    assertEquals(b_double(23.0), b_short(23) * b_double(1.0))
    assertEquals(b_double(-23.0), b_short(23) * b_double(-1.0))
    assertEquals(b_double(529.0), b_short(23) * b_double(23.0))
    assertEquals(b_double(531.8290000000001), b_short(23) * b_double(23.123))
    assertEquals(b_double(-736.0), b_short(23) * b_double(-32.0))
    assertEquals(b_double(-746.488), b_short(23) * b_double(-32.456))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(23) * b_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(23) * b_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(23) * b_double(Double.NaN_))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(23) * b_double(Double.MAX_VALUE))
    assertEquals(b_double(Double.parseDouble("1.14E-322")), b_short(23) * b_double(Double.MIN_VALUE))

    assertEquals(b_double(-0.0), b_short(-32) * b_double(0.0))
    assertEquals(b_double(-32.0), b_short(-32) * b_double(1.0))
    assertEquals(b_double(32.0), b_short(-32) * b_double(-1.0))
    assertEquals(b_double(-736.0), b_short(-32) * b_double(23.0))
    assertEquals(b_double(-739.936), b_short(-32) * b_double(23.123))
    assertEquals(b_double(1024.0), b_short(-32) * b_double(-32.0))
    assertEquals(b_double(1038.592), b_short(-32) * b_double(-32.456))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(-32) * b_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(-32) * b_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(-32) * b_double(Double.NaN_))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(-32) * b_double(Double.MAX_VALUE))
    assertEquals(b_double(Double.parseDouble("-1.58E-322")), b_short(-32) * b_double(Double.MIN_VALUE))

    assertEquals(b_double(0.0), b_short(Short.MAX_VALUE) * b_double(0.0))
    assertEquals(b_double(32767.0), b_short(Short.MAX_VALUE) * b_double(1.0))
    assertEquals(b_double(-32767.0), b_short(Short.MAX_VALUE) * b_double(-1.0))
    assertEquals(b_double(753641.0), b_short(Short.MAX_VALUE) * b_double(23.0))
    assertEquals(b_double(757671.341), b_short(Short.MAX_VALUE) * b_double(23.123))
    assertEquals(b_double(-1048544.0), b_short(Short.MAX_VALUE) * b_double(-32.0))
    assertEquals(b_double(-1063485.752), b_short(Short.MAX_VALUE) * b_double(-32.456))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(Short.MAX_VALUE) * b_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(Short.MAX_VALUE) * b_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(Short.MAX_VALUE) * b_double(Double.NaN_))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(Short.MAX_VALUE) * b_double(Double.MAX_VALUE))
    assertEquals(b_double(Double.parseDouble("1.6189E-319")), b_short(Short.MAX_VALUE) * b_double(Double.MIN_VALUE))

    assertEquals(b_double(-0.0), b_short(Short.MIN_VALUE) * b_double(0.0))
    assertEquals(b_double(-32768.0), b_short(Short.MIN_VALUE) * b_double(1.0))
    assertEquals(b_double(32768.0), b_short(Short.MIN_VALUE) * b_double(-1.0))
    assertEquals(b_double(-753664.0), b_short(Short.MIN_VALUE) * b_double(23.0))
    assertEquals(b_double(-757694.464), b_short(Short.MIN_VALUE) * b_double(23.123))
    assertEquals(b_double(1048576.0), b_short(Short.MIN_VALUE) * b_double(-32.0))
    assertEquals(b_double(1063518.208), b_short(Short.MIN_VALUE) * b_double(-32.456))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(Short.MIN_VALUE) * b_double(Double.POSITIVE_INFINITY))
    assertEquals(b_double(Double.POSITIVE_INFINITY), b_short(Short.MIN_VALUE) * b_double(Double.NEGATIVE_INFINITY))
    assertEquals(b_double(Double.NaN_), b_short(Short.MIN_VALUE) * b_double(Double.NaN_))
    assertEquals(b_double(Double.NEGATIVE_INFINITY), b_short(Short.MIN_VALUE) * b_double(Double.MAX_VALUE))
    assertEquals(b_double(Double.parseDouble("-1.61895E-319")), b_short(Short.MIN_VALUE) * b_double(Double.MIN_VALUE))

    assertEquals(Double, statictypeof(b_short(0) * b_double(0.0)))
  }

  function testShortBigIntegerMultiplication() {
    assertEquals(big_int("0"), b_short(0) * big_int("0"))
    assertEquals(big_int("0"), b_short(0) * big_int("1"))
    assertEquals(big_int("0"), b_short(0) * big_int("-1"))
    assertEquals(big_int("0"), b_short(0) * big_int("23"))
    assertEquals(big_int("0"), b_short(0) * big_int("-32"))
    assertEquals(big_int("0"), b_short(0) * big_int("123456789012345678901234567890"))
    assertEquals(big_int("0"), b_short(0) * big_int("-123456789012345678901234567890"))

    assertEquals(big_int("0"), b_short(1) * big_int("0"))
    assertEquals(big_int("1"), b_short(1) * big_int("1"))
    assertEquals(big_int("-1"), b_short(1) * big_int("-1"))
    assertEquals(big_int("23"), b_short(1) * big_int("23"))
    assertEquals(big_int("-32"), b_short(1) * big_int("-32"))
    assertEquals(big_int("123456789012345678901234567890"), b_short(1) * big_int("123456789012345678901234567890"))
    assertEquals(big_int("-123456789012345678901234567890"), b_short(1) * big_int("-123456789012345678901234567890"))

    assertEquals(big_int("0"), b_short(-1) * big_int("0"))
    assertEquals(big_int("-1"), b_short(-1) * big_int("1"))
    assertEquals(big_int("1"), b_short(-1) * big_int("-1"))
    assertEquals(big_int("-23"), b_short(-1) * big_int("23"))
    assertEquals(big_int("32"), b_short(-1) * big_int("-32"))
    assertEquals(big_int("-123456789012345678901234567890"), b_short(-1) * big_int("123456789012345678901234567890"))
    assertEquals(big_int("123456789012345678901234567890"), b_short(-1) * big_int("-123456789012345678901234567890"))

    assertEquals(big_int("0"), b_short(23) * big_int("0"))
    assertEquals(big_int("23"), b_short(23) * big_int("1"))
    assertEquals(big_int("-23"), b_short(23) * big_int("-1"))
    assertEquals(big_int("529"), b_short(23) * big_int("23"))
    assertEquals(big_int("-736"), b_short(23) * big_int("-32"))
    assertEquals(big_int("2839506147283950614728395061470"), b_short(23) * big_int("123456789012345678901234567890"))
    assertEquals(big_int("-2839506147283950614728395061470"), b_short(23) * big_int("-123456789012345678901234567890"))

    assertEquals(big_int("0"), b_short(-32) * big_int("0"))
    assertEquals(big_int("-32"), b_short(-32) * big_int("1"))
    assertEquals(big_int("32"), b_short(-32) * big_int("-1"))
    assertEquals(big_int("-736"), b_short(-32) * big_int("23"))
    assertEquals(big_int("1024"), b_short(-32) * big_int("-32"))
    assertEquals(big_int("-3950617248395061724839506172480"), b_short(-32) * big_int("123456789012345678901234567890"))
    assertEquals(big_int("3950617248395061724839506172480"), b_short(-32) * big_int("-123456789012345678901234567890"))

    assertEquals(big_int("0"), b_short(Short.MAX_VALUE) * big_int("0"))
    assertEquals(big_int("32767"), b_short(Short.MAX_VALUE) * big_int("1"))
    assertEquals(big_int("-32767"), b_short(Short.MAX_VALUE) * big_int("-1"))
    assertEquals(big_int("753641"), b_short(Short.MAX_VALUE) * big_int("23"))
    assertEquals(big_int("-1048544"), b_short(Short.MAX_VALUE) * big_int("-32"))
    assertEquals(big_int("4045308605567530860556753086051630"), b_short(Short.MAX_VALUE) * big_int("123456789012345678901234567890"))
    assertEquals(big_int("-4045308605567530860556753086051630"), b_short(Short.MAX_VALUE) * big_int("-123456789012345678901234567890"))

    assertEquals(big_int("0"), b_short(Short.MIN_VALUE) * big_int("0"))
    assertEquals(big_int("-32768"), b_short(Short.MIN_VALUE) * big_int("1"))
    assertEquals(big_int("32768"), b_short(Short.MIN_VALUE) * big_int("-1"))
    assertEquals(big_int("-753664"), b_short(Short.MIN_VALUE) * big_int("23"))
    assertEquals(big_int("1048576"), b_short(Short.MIN_VALUE) * big_int("-32"))
    assertEquals(big_int("-4045432062356543206235654320619520"), b_short(Short.MIN_VALUE) * big_int("123456789012345678901234567890"))
    assertEquals(big_int("4045432062356543206235654320619520"), b_short(Short.MIN_VALUE) * big_int("-123456789012345678901234567890"))

    assertEquals(BigInteger, statictypeof(b_short(0) * big_int("0")))
  }

  function testShortBigDecimalMultiplication() {
    assertEquals(big_decimal("0"), b_short(0) * big_decimal("0"))
    assertEquals(big_decimal("0"), b_short(0) * big_decimal("1"))
    assertEquals(big_decimal("0"), b_short(0) * big_decimal("-1"))
    assertEquals(big_decimal("0"), b_short(0) * big_decimal("23"))
    assertEquals(big_decimal("0.000"), b_short(0) * big_decimal("23.123"))
    assertEquals(big_decimal("0"), b_short(0) * big_decimal("-32"))
    assertEquals(big_decimal("0.000"), b_short(0) * big_decimal("-32.456"))
    assertEquals(big_decimal("0E-9"), b_short(0) * big_decimal("123456789012345678901234567890.123456789"))
    assertEquals(big_decimal("0E-9"), b_short(0) * big_decimal("-123456789012345678901234567890.123456789"))

    assertEquals(big_decimal("0"), b_short(1) * big_decimal("0"))
    assertEquals(big_decimal("1"), b_short(1) * big_decimal("1"))
    assertEquals(big_decimal("-1"), b_short(1) * big_decimal("-1"))
    assertEquals(big_decimal("23"), b_short(1) * big_decimal("23"))
    assertEquals(big_decimal("23.123"), b_short(1) * big_decimal("23.123"))
    assertEquals(big_decimal("-32"), b_short(1) * big_decimal("-32"))
    assertEquals(big_decimal("-32.456"), b_short(1) * big_decimal("-32.456"))
    assertEquals(big_decimal("123456789012345678901234567890.123456789"), b_short(1) * big_decimal("123456789012345678901234567890.123456789"))
    assertEquals(big_decimal("-123456789012345678901234567890.123456789"), b_short(1) * big_decimal("-123456789012345678901234567890.123456789"))

    assertEquals(big_decimal("0"), b_short(-1) * big_decimal("0"))
    assertEquals(big_decimal("-1"), b_short(-1) * big_decimal("1"))
    assertEquals(big_decimal("1"), b_short(-1) * big_decimal("-1"))
    assertEquals(big_decimal("-23"), b_short(-1) * big_decimal("23"))
    assertEquals(big_decimal("-23.123"), b_short(-1) * big_decimal("23.123"))
    assertEquals(big_decimal("32"), b_short(-1) * big_decimal("-32"))
    assertEquals(big_decimal("32.456"), b_short(-1) * big_decimal("-32.456"))
    assertEquals(big_decimal("-123456789012345678901234567890.123456789"), b_short(-1) * big_decimal("123456789012345678901234567890.123456789"))
    assertEquals(big_decimal("123456789012345678901234567890.123456789"), b_short(-1) * big_decimal("-123456789012345678901234567890.123456789"))

    assertEquals(big_decimal("0"), b_short(23) * big_decimal("0"))
    assertEquals(big_decimal("23"), b_short(23) * big_decimal("1"))
    assertEquals(big_decimal("-23"), b_short(23) * big_decimal("-1"))
    assertEquals(big_decimal("529"), b_short(23) * big_decimal("23"))
    assertEquals(big_decimal("531.829"), b_short(23) * big_decimal("23.123"))
    assertEquals(big_decimal("-736"), b_short(23) * big_decimal("-32"))
    assertEquals(big_decimal("-746.488"), b_short(23) * big_decimal("-32.456"))
    assertEquals(big_decimal("2839506147283950614728395061472.839506147"), b_short(23) * big_decimal("123456789012345678901234567890.123456789"))
    assertEquals(big_decimal("-2839506147283950614728395061472.839506147"), b_short(23) * big_decimal("-123456789012345678901234567890.123456789"))

    assertEquals(big_decimal("0"), b_short(-32) * big_decimal("0"))
    assertEquals(big_decimal("-32"), b_short(-32) * big_decimal("1"))
    assertEquals(big_decimal("32"), b_short(-32) * big_decimal("-1"))
    assertEquals(big_decimal("-736"), b_short(-32) * big_decimal("23"))
    assertEquals(big_decimal("-739.936"), b_short(-32) * big_decimal("23.123"))
    assertEquals(big_decimal("1024"), b_short(-32) * big_decimal("-32"))
    assertEquals(big_decimal("1038.592"), b_short(-32) * big_decimal("-32.456"))
    assertEquals(big_decimal("-3950617248395061724839506172483.950617248"), b_short(-32) * big_decimal("123456789012345678901234567890.123456789"))
    assertEquals(big_decimal("3950617248395061724839506172483.950617248"), b_short(-32) * big_decimal("-123456789012345678901234567890.123456789"))

    assertEquals(big_decimal("0"), b_short(Short.MAX_VALUE) * big_decimal("0"))
    assertEquals(big_decimal("32767"), b_short(Short.MAX_VALUE) * big_decimal("1"))
    assertEquals(big_decimal("-32767"), b_short(Short.MAX_VALUE) * big_decimal("-1"))
    assertEquals(big_decimal("753641"), b_short(Short.MAX_VALUE) * big_decimal("23"))
    assertEquals(big_decimal("757671.341"), b_short(Short.MAX_VALUE) * big_decimal("23.123"))
    assertEquals(big_decimal("-1048544"), b_short(Short.MAX_VALUE) * big_decimal("-32"))
    assertEquals(big_decimal("-1063485.752"), b_short(Short.MAX_VALUE) * big_decimal("-32.456"))
    assertEquals(big_decimal("4045308605567530860556753086055675.308605163"), b_short(Short.MAX_VALUE) * big_decimal("123456789012345678901234567890.123456789"))
    assertEquals(big_decimal("-4045308605567530860556753086055675.308605163"), b_short(Short.MAX_VALUE) * big_decimal("-123456789012345678901234567890.123456789"))

    assertEquals(big_decimal("0"), b_short(Short.MIN_VALUE) * big_decimal("0"))
    assertEquals(big_decimal("-32768"), b_short(Short.MIN_VALUE) * big_decimal("1"))
    assertEquals(big_decimal("32768"), b_short(Short.MIN_VALUE) * big_decimal("-1"))
    assertEquals(big_decimal("-753664"), b_short(Short.MIN_VALUE) * big_decimal("23"))
    assertEquals(big_decimal("-757694.464"), b_short(Short.MIN_VALUE) * big_decimal("23.123"))
    assertEquals(big_decimal("1048576"), b_short(Short.MIN_VALUE) * big_decimal("-32"))
    assertEquals(big_decimal("1063518.208"), b_short(Short.MIN_VALUE) * big_decimal("-32.456"))
    assertEquals(big_decimal("-4045432062356543206235654320623565.432061952"), b_short(Short.MIN_VALUE) * big_decimal("123456789012345678901234567890.123456789"))
    assertEquals(big_decimal("4045432062356543206235654320623565.432061952"), b_short(Short.MIN_VALUE) * big_decimal("-123456789012345678901234567890.123456789"))

    assertEquals(BigDecimal, statictypeof(b_short(0) * big_decimal("0")))
  }

}

